// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "myodbctest.h"
#include "ChildView.h"
#include "BlobDataRS.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	//}}AFX_MSG_MAP

	ON_BN_CLICKED(IDC_TEST, OnTest)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	// Do not call CWnd::OnPaint() for painting messages
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	m_btnTest.Create(_T("Test MyODBC"), WS_CHILD | WS_VISIBLE, CRect(50, 50, 150, 75), this, IDC_TEST);

	return 0;
}

void CChildView::OnTest()
{
	// connect to MySQL using MyODBC
	CDatabase db;
	VERIFY(db.OpenEx(_T("Driver={MySQL ODBC 3.51 Driver};Server=localhost;Option=298;User=root;db=test"), CDatabase::noOdbcDialog));
	
	// delete existing records from table
	db.ExecuteSQL(_T("DELETE FROM blob_data"));

	// try inserting a blob with 6000 bytes of data (it should work)
	InsertBlob(&db, 6000);

	// now try inserting a blob with 9000 bytes of data (this will crash)
	InsertBlob(&db, 9000);

	db.Close();
}

void CChildView::InsertBlob(CDatabase* pDb, const int nColumnSize)
{
	// create and open recordset object
	CBlobDataRS rs(pDb);
	rs.m_nColumnSize = nColumnSize;
	rs.Open();

	// add test recordset to database
	rs.AddNew();

	// populate sample binary data
	rs.m_data.SetSize(rs.m_nColumnSize);

	for (int i = 0; i < rs.m_nColumnSize; i++)
	{
		rs.m_data[i] = 1;
	}

	// save record
	rs.Update();

	// display success message box to user
	CString strMsg;
	strMsg.Format(_T("Blob insert of %d bytes was successful"), nColumnSize);
	AfxMessageBox(strMsg, MB_OK);

	return;
}
